# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/04_enum/02_unit.ipynb.

# %% auto 0
__all__ = ['ONE', 'DECA', 'HECTO', 'KILO', 'MEGA', 'GIGA', 'TERA', 'PETA', 'EXA', 'ZETTA', 'YOTTA', 'RONNA', 'QUETTA', 'DECI',
           'CENTI', 'MILLI', 'MICRO', 'NANO', 'PICO', 'FEMTO', 'ATTO', 'ZEPTO', 'YOCTO', 'RONTO', 'QUECTO', 'ExpInfo',
           'Unit']

# %% ../../nbs/04_enum/02_unit.ipynb 4
from enum import Enum
from typing import NamedTuple

# %% ../../nbs/04_enum/02_unit.ipynb 5
from ..nlit.unit import UNIT_NAMES, UNIT_ABRVS, UNIT_SYMBS

# %% ../../nbs/04_enum/02_unit.ipynb 7
class ExpInfo(NamedTuple):
    name: str; abrv: str; symb: str; expo: float;

ONE    = ExpInfo(UNIT_NAMES[0], UNIT_ABRVS[0], UNIT_SYMBS[0], 1e0)

DECA   = ExpInfo(UNIT_NAMES[1],  UNIT_ABRVS[1],  UNIT_SYMBS[1],  1e+1)
HECTO  = ExpInfo(UNIT_NAMES[2],  UNIT_ABRVS[2],  UNIT_SYMBS[2],  1e+2)
KILO   = ExpInfo(UNIT_NAMES[3],  UNIT_ABRVS[3],  UNIT_SYMBS[3],  1e+3)
MEGA   = ExpInfo(UNIT_NAMES[4],  UNIT_ABRVS[4],  UNIT_SYMBS[4],  1e+6)
GIGA   = ExpInfo(UNIT_NAMES[5],  UNIT_ABRVS[5],  UNIT_SYMBS[5],  1e+9)
TERA   = ExpInfo(UNIT_NAMES[6],  UNIT_ABRVS[6],  UNIT_SYMBS[6],  1e+12)
PETA   = ExpInfo(UNIT_NAMES[7],  UNIT_ABRVS[7],  UNIT_SYMBS[7],  1e+15)
EXA    = ExpInfo(UNIT_NAMES[8],  UNIT_ABRVS[8],  UNIT_SYMBS[8],  1e+18)
ZETTA  = ExpInfo(UNIT_NAMES[9],  UNIT_ABRVS[9],  UNIT_SYMBS[9],  1e+21)
YOTTA  = ExpInfo(UNIT_NAMES[10], UNIT_ABRVS[10], UNIT_SYMBS[10], 1e+24)
RONNA  = ExpInfo(UNIT_NAMES[11], UNIT_ABRVS[11], UNIT_SYMBS[11], 1e+27)
QUETTA = ExpInfo(UNIT_NAMES[12], UNIT_ABRVS[12], UNIT_SYMBS[12], 1e+30)

DECI   = ExpInfo(UNIT_NAMES[13], UNIT_ABRVS[13], UNIT_SYMBS[13], 1e-1)
CENTI  = ExpInfo(UNIT_NAMES[14], UNIT_ABRVS[14], UNIT_SYMBS[14], 1e-2)
MILLI  = ExpInfo(UNIT_NAMES[15], UNIT_ABRVS[15], UNIT_SYMBS[15], 1e-3)
MICRO  = ExpInfo(UNIT_NAMES[16], UNIT_ABRVS[16], UNIT_SYMBS[16], 1e-6)
NANO   = ExpInfo(UNIT_NAMES[17], UNIT_ABRVS[17], UNIT_SYMBS[17], 1e-9)
PICO   = ExpInfo(UNIT_NAMES[18], UNIT_ABRVS[18], UNIT_SYMBS[18], 1e-12)
FEMTO  = ExpInfo(UNIT_NAMES[19], UNIT_ABRVS[19], UNIT_SYMBS[19], 1e-15)
ATTO   = ExpInfo(UNIT_NAMES[20], UNIT_ABRVS[20], UNIT_SYMBS[20], 1e-18)
ZEPTO  = ExpInfo(UNIT_NAMES[21], UNIT_ABRVS[21], UNIT_SYMBS[21], 1e-21)
YOCTO  = ExpInfo(UNIT_NAMES[22], UNIT_ABRVS[22], UNIT_SYMBS[22], 1e-24)
RONTO  = ExpInfo(UNIT_NAMES[23], UNIT_ABRVS[23], UNIT_SYMBS[23], 1e-27)
QUECTO = ExpInfo(UNIT_NAMES[24], UNIT_ABRVS[24], UNIT_SYMBS[24], 1e-30)

# %% ../../nbs/04_enum/02_unit.ipynb 8
class Unit(Enum):
    ONE    = ONE
    DECA   = DECA
    HECTO  = HECTO
    KILO   = KILO
    MEGA   = MEGA
    GIGA   = GIGA
    TERA   = TERA
    PETA   = PETA
    EXA    = EXA
    ZETTA  = ZETTA
    YOTTA  = YOTTA
    RONNA  = RONNA
    QUETTA = QUETTA
    DECI   = DECI
    CENTI  = CENTI
    MILLI  = MILLI
    MICRO  = MICRO
    NANO   = NANO
    PICO   = PICO
    FEMTO  = FEMTO
    ATTO   = ATTO
    ZEPTO  = ZEPTO
    YOCTO  = YOCTO
    RONTO  = RONTO
    QUECTO = QUECTO
