# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/10_join.ipynb.

# %% auto 0
__all__ = ['charjoin', 'splitjoin', 'stripjoin', 'dotstr', 'dashstr', 's_str', 'd_str', 'ustr', 'dustr', 'u1str', 'u2str',
           'sunstr', 'dunstr', 'nilstr']

# %% ../nbs/10_join.ipynb 4
from typing import Any, Union, TypeAlias
from atyp import StrQ, StrGuard
from nchr import DOT, DASH, U1, U2, NIL
from chck import istuple
from atup import argtup

# %% ../nbs/10_join.ipynb 6
def charjoin(char: str, *strs) -> str: 
    return char.join(tuple(map(str, tuple(argtup(strs)))))

def splitjoin(s: str, sep: str = DOT, char: str = U1) -> str:
    return char.join(s.split(sep))
    
def stripjoin(*args: str, sep: str = DOT) -> str:
    return sep.join([s.strip(sep) for s in args])

# %% ../nbs/10_join.ipynb 7
def dotstr(*strs) -> str:  return charjoin(DOT, *strs)

def dashstr(*strs) -> str: return charjoin(DASH, *strs)

def s_str(*strs)  -> str:  return charjoin(U1, *strs)
def d_str(*strs)  -> str:  return charjoin(U2, *strs)
def ustr(*strs)   -> str:  return s_str(*strs)
def dustr(*strs)  -> str:  return d_str(*strs)
def u1str(*strs)  -> str:  return s_str(*strs)
def u2str(*strs)  -> str:  return d_str(*strs)
def sunstr(*strs) -> str:  return s_str(*strs)
def dunstr(*strs) -> str:  return d_str(*strs)

def nilstr(*strs) -> str:  return charjoin(NIL, *strs)
